<template>
  <div id='QuestionBox'>
    <div id='QuestionBox__title'>{{title}}</div>
    <p id='QuestionBox__question' v-html='questionHTML'></p>
    <textarea v-model='message' placeholder='Enter here' @input='changeString()'
              @enter="answer+=','"/>
    <MathLine :answer='answer'/>
    <div id="QuestionBox__answer">
      <button :class="[solvedQuestion===''?'' : 'QuestionBox__answer--button']"
              @click="questionSolver()">Show answer
      </button>
      {{solvedQuestion}}
    </div>
  </div>
</template>

<script lang='ts'>
  import MathLine from './MathLine.vue';
  import {Component, Prop, Vue} from 'vue-property-decorator';
  import * as Maths from '../common/Maths';

  @Component({
    name: 'questionBox',
    components: {
      MathLine,
    },
  })
  export default class QuestionBox extends Vue {
    @Prop(String) private readonly question!: string;
    @Prop(String) private readonly title!: string;

    private message = '';
    private answer = '';
    private questionHTML = '';
    private solvedQuestion = '';

    private mounted() {
      this.questionHTML = this.question.replace(/(\^[0-9]{1,})+/g, '<sup>2</sup>');
    }

    private changeString() {
      this.answer = this.message.replace(/(\^[0-9]{1,})+/g,
        (match) => `<sup>${match.replace('^', '')}</sup>`);
    }

    private questionSolver() {
      if (this.title.includes('Solve')) {
        this.solvedQuestion = Maths.quadraticSolver(this.question).join(', ');
      } else if (this.title.includes('Simplify')) {
        this.solvedQuestion = Maths.basicAlgebraSolver(this.question).join(' ');
      }
    }
  }
</script>

<style>
  #QuestionBox {
    background-color: #ffff;
    -webkit-box-shadow: 10px 10px 15px -8px rgba(0, 0, 0, 0.75);
    -moz-box-shadow: 10px 10px 15px -8px rgba(0, 0, 0, 0.75);
    box-shadow: 10px 10px 15px -8px rgba(0, 0, 0, 0.75);
    width: 50%;
    display: inline-block;
    margin: 0.5rem;
  }

  #QuestionBox__title {
    border-bottom: 0.125rem solid black;
    font-weight: bold;
    text-align: left;
    font-size: 1.2em;
  }

  #QuestionBox__question {
    font-weight: bold;
  }

  .QuestionBox__answer--button {
    display: none;
  }

  #QuestionBox__answer {
    margin: 0 auto;
    position: relative;
  }
</style>
